@echo off
cls
	rem ################################################################
	rem #                                                              #
	rem #  Skript zur Auswahl des Standarddruckers durch den Benutzer  #
	rem #  =========================================================   #
	rem #  Author by Ruedi Steiger, Switzerland born in 1965, Basel    #
	rem #                     v1.0 - Created 16.04.2015                #
	rem #                                                              #
	rem # Licence: GPL - Please take note the Author in your scripts   #
	rem ################################################################
	rem #  Syntax:   [AuswahlDefaultPrinter.cmd]                       #
	rem #  Defaults: [%ALLUSERSPROFILE%\%USERNAME%_DefaultPrinter.cmd] #
	rem ################################################################
	rem #  Install-Instruktions                                        #
	rem #  ====================                                        #
	rem #  1. Define your User-Defautls Printers on preferred day      #
	rem #     and all Printernames you wish to use on you              #
	rem #     Computer in your [Loginname_DefaultPrinter.cmd]-File     #
	rem #                                                              #
	rem #  2. Put the %USERNAME%_DefaultPrinter.cmd                    #
	rem #     in your [%ALLUSERSPROFILE%]-Directory                    #
	rem #                                                              #
	rem #  3. Put this file in Install-Folder and make a Link          #
	rem #                                                              #
	rem #  4. Put this Link in your Autostart-Directory                #
	rem ################################################################
goto :getDefault

:getDefault
	CALL "%ALLUSERSPROFILE%\%USERNAME%_DefaultPrinter.cmd"
goto :heute

:heute
      rem Ermittelt aktuelles Daum
	FOR /F "tokens=3 delims=. " %%a in ('date/T') DO set YYYY=%%a
	FOR /F "tokens=2 delims=. " %%a in ('date/T') DO set MM=%%a
	FOR /F "tokens=1 delims=. " %%a in ('date/T') DO set DD=%%a

      rem Ermittelt Wochentag-Nr. von Datum (Batchcode aus dem Internet)
	call getDow %YYYY% %MM% %DD% nWochentag

      rem Ermittelt Wochentagsbezeichnung anhand der Wochentag-Nr.
	IF %nWochentag%==1 SET TagHeute=Mo
	IF %nWochentag%==2 SET TagHeute=Di
	IF %nWochentag%==3 SET TagHeute=Mi
	IF %nWochentag%==4 SET TagHeute=Do
	IF %nWochentag%==5 SET TagHeute=Fr
	IF %nWochentag%==6 SET TagHeute=Sa
	IF %nWochentag%==7 SET TagHeute=So

      rem Ermittelt Monatsbezeichnung anhand der MM-Zahl
	IF %MM%==01 SET Monat=Januar
	IF %MM%==02 SET Monat=Februar
	IF %MM%==03 SET Monat=Maerz
	IF %MM%==04 SET Monat=April
	IF %MM%==05 SET Monat=Mai
	IF %MM%==06 SET Monat=Juni
	IF %MM%==07 SET Monat=Juli
	IF %MM%==08 SET Monat=August
	IF %MM%==09 SET Monat=September
	IF %MM%==10 SET Monat=Oktober
	IF %MM%==11 SET Monat=November
	IF %MM%==12 SET Monat=Dezember

      rem Ermittelt Wochentagsbezeichnung anhand der DD-Zahl
	IF %TagHeute%==Mo SET Wochentag=Montag
	IF %TagHeute%==Di SET Wochentag=Dienstag
	IF %TagHeute%==Mi SET Wochentag=Mittwoch
	IF %TagHeute%==Do SET Wochentag=Donnerstag
	IF %TagHeute%==Fr SET Wochentag=Freitag
	IF %TagHeute%==Sa SET Wochentag=Samstag
	IF %TagHeute%==So SET Wochentag=Sonntag

      rem Setze Tag fuer Radio-Button auf Standarddrucker am entsprechenden Tag
	IF %TagHeute%==Mo SET Mo=%PrintMo%
	IF %TagHeute%==Mo SET MoName=%PrintMoName%
	IF %TagHeute%==Di SET Di=%PrintDi%
	IF %TagHeute%==Di SET DiName=%PrintDiName%
	IF %TagHeute%==Mi SET Mi=%PrintMi%
	IF %TagHeute%==Mi SET MiName=%PrintMiName%
	IF %TagHeute%==Do SET Do=%PrintDo%
	IF %TagHeute%==Do SET DoName=%PrintDoName%
	IF %TagHeute%==Fr SET Fr=%PrintFr%
	IF %TagHeute%==Fr SET FrName=%PrintFrName%
	IF %TagHeute%==Sa SET Sa=%PrintSa%
	IF %TagHeute%==Sa SET SaName=%PrintSaName%
	IF %TagHeute%==So SET So=%PrintSo%
	IF %TagHeute%==So SET SoName=%PrintSoName%

      rem Bezeichnung Standarddrucker bennen
	SET Print00=Standarddrucker verwenden
	SET Print00Name=%MoName%%DiName%%MiName%%DoName%%FrName%%SaName%%SoName%
	ECHO        Tagesstandard-Drucker: [%Print00Name%]

      rem echo TagHeute [%TagHeute%]
      rem echo ==============================
      rem pause
goto :menu

:menu
        set page=menu
        set back=menu
	set wabmp=IconDefaultPrint.bmp
        set waico=IconDefaultPrint.ico
        set watitle=Auswahl - Standardrucker
        set watext=~  %Wochentag%, %DD%. %Monat% %YYYY%  
        set watext=%watext%~~  Bitte waehlen Sie Ihren Tages Standarddrucker aus !
        set watext=%watext%~ 
        set watext=%watext%~   Ihr [%USERNAME%] Standarddrucker ist heute 
        set watext=%watext%~   [ %Mo%%Di%%Mi%%Do%%Fr%%Sa%%So% ]
        set watext=%watext%~   ----------------------------------------------------------------------------------
        set wabat=
        set wabat=%TEMP%\wabat.bat
        set waoutput= %Print00%;;;;;;;
        set wainput= %Print00%; %Print01%; %Print02%; %Print03%; %Print04%; %Print05%; %Print06%; %Print07%; %Print08%; %Print09%
        set errorlevel=

        rem --- Dialog anzeigen ---
        start /w wizapp RB

        rem --- Abbruch prfen ---
        if errorlevel 2 goto :cancel
        if errorlevel 1 goto :%back%

        rem --- Inhalt auslesen ---
        call %wabat%
        if errorlevel 0   goto :execute
goto :menu


:execute
        for %%c in (0 1 2 3 4 5 6 7 8 9) do set chk%%c=
            for %%c in (%waoutnum%) do set chk%%c=1
            if "%chk0%"=="1" SET DEFAULT=%Print00Name%
            if "%chk1%"=="1" SET DEFAULT=%Print01Name%
            if "%chk2%"=="1" SET DEFAULT=%Print02Name%
            if "%chk3%"=="1" SET DEFAULT=%Print03Name%
            if "%chk4%"=="1" SET DEFAULT=%Print04Name%
            if "%chk5%"=="1" SET DEFAULT=%Print05Name%
            if "%chk6%"=="1" SET DEFAULT=%Print06Name%
            if "%chk7%"=="1" SET DEFAULT=%Print07Name%
            if "%chk8%"=="1" SET DEFAULT=%Print08Name%
            if "%chk9%"=="1" SET DEFAULT=%Print09Name%
goto :check_choise

:check_choise
	call check-printer.cmd %DEFAULT%
	IF %DRUCKER_OK%==OK goto :ChangeDefault
	IF %DRUCKER_OK%==BAD goto :Support
goto :Support

:Support
      rem Printer-Driver not exist on your system
        set page=menu
        set back=menu
        set waico=IconDefaultPrint.ico
        set watitle=Standardrucker-Treiber fehlen !
        set watext=~  Dieser Drucker [%DEFAULT%] ist nicht auf Ihrem Computer installiert!
        set watext=%watext%~~ Wenden Sie sich an Ihren IT-Support, um diesen installieren
        set watext=%watext%~ und konfigurieren zu lassen und wiederholen Sie diesen Vorgang.
        set wabat=
        set wabat=%TEMP%\wabat.bat
        set errorlevel=

        rem --- Dialog anzeigen ---
        start /w wizapp MB STOP

	rem pause
goto :exit


:ChangeDefault
	call C:\WINDOWS\system32\rundll32.exe printui.dll,PrintUIEntry /y /n "%DEFAULT%"
        set page=menu
        set back=menu
        set waico=IconDefaultPrint.ico
        set watitle=Standardrucker festgelegt !
        set watext=~  Ihr neuer Standarddrucker ist~  [%DEFAULT%]
        set wabat=
        set wabat=%TEMP%\wabat.bat
        set errorlevel=

        rem --- Dialog anzeigen ---
        start /w wizapp MB INFORMATION

	rem pause	
goto :exit

:exit
